/**
 * \file LocalizationInterface.h
 * Contains class definitions for ObjectPosition,
 * ObjectPositionVariance, ObjectPositionDistribution, and the
 * interface class LocalizationInterface.
 */
#ifndef LOCALIZATIONINTERFACE_H
#define LOCALIZATIONINTERFACE_H

#include "WorldState.h"

/**
 * \class LocalizationInterface
 * Interface for a container class for locations
 * (ObjectPositionDistribution) of all of the objects on the field.
 */
class LocalizationInterface
{
public:
  /**
   * Typical virtual destructor.
   */
  virtual ~LocalizationInterface() { }

  /**
   * Update the WorldState from the information provided.
   * Of course, any implementation of this function would have more
   * detail as to where it gets that information.
   */
  virtual void UpdateWorldState( WorldState *ws ) = 0;
};

#endif  // LOCALIZATIONINTERFACE_H
