#ifndef _LOGGER_H
#define _LOGGER_H

#include <iostream.h>
#include <ostream.h>
#include <fstream.h>
#include <sys/time.h>
#include <string>
#include <iomanip.h>
#include <set>

class Player;

#define MAX_LOG_LINE 2048
#define MAX_HEADER 128

using namespace std;

class Timing
{
 private:
  struct timeval time1;

 public:
  static double getTimeDifference( struct timeval t1,
				   struct timeval t2 );
  void printTimeDiffWithText( ostream& os,
			      char *str,
			      int iFactor = 1000 );
  double getElapsedTime();
  void restartTime();
} ;

class Logger
{
 private:
  Timing m_timing;
  char m_buf[MAX_LOG_LINE];
  set<int> m_setLogLevels;
  char m_strHeader[MAX_HEADER];
  ostream* m_os;

  Player *P;

 public:
  Logger( ostream& os=cout, int iMinLogLevel=0, int iMaxLogLevel = 0 );

  bool setPlayer( Player *p );

  // different methods associated with logging messages
  bool     log              ( int      iLevel, string str              );
  bool     log              ( int      i,      char   *str, ...        );
  bool     logWithTime      ( int      iLevel, char   *str, ...        );
  void     restartTimer     (                                          );
  Timing   getTiming        (                                          );   
  bool     isInLogLevel     ( int      iLevel                          );

  bool     addLogLevel      ( int      iLevel                          );
  bool     addLogRange      ( int      iMin,   int iMax                );
  
  char*    getHeader        (                                          );
  bool     setHeader        ( char     *str                            );
  bool     setHeader        ( int      i1,     int    i2               );

  bool     setOutputStream  ( ostream& os                              );
  ostream& getOutputStream  (                                          );  
  void     showLogLevels    ( ostream& os                              );
} ;

#endif //_LOGGER_H
