#include "Parse.h"

#include <ctype.h>
#include <math.h>
#include <string.h>
using namespace std;

char Parse::gotoFirstNonSpace( char** strMsg )
{
  while ( *strMsg && isspace( **strMsg ) )
    (*strMsg)++;
  return (*strMsg) ? **strMsg : '\0';
}

char Parse::gotoFirstSpaceOrClosingBracket( char** strMsg )
{
  while ( *strMsg && **strMsg!=' ' && **strMsg!=')' )
    (*strMsg)++;
  return  (*strMsg) ? **strMsg : '\0';
}

int Parse::gotoFirstOccurenceOf( char c, char** strMsg )
{
  int i=0;
  while( **strMsg && **strMsg != c ) {
    i++;
    (*strMsg)++;
  }
  if ( ! **strMsg )
    return -1;
  return i;
}

int Parse::parseFirstInt( char** strMsg )
{
  int  iRes  = 0;
  bool bIsMin= false;
  char *str  = *strMsg;

  while ( *str != '\0' && !isdigit(*str) && *str!='-' )
    str++;                             // walk to first non digit or minus sign


  if ( *str != '\0' && *str=='-' ) {
    bIsMin=true;
    str++;
  }

  while ( *str != '\0' && *str<='9' && *str>='0' ) {
    iRes=iRes*10+(int)(*str-'0');                 // multiply old res with 10
    str++;                                        // and add new value
  }
  *strMsg = str;
  return (bIsMin) ? -iRes : iRes;
}

double Parse::parseFirstDouble( char** strMsg )
{
  double dRes=0.0, dFrac=1.0;
  bool bIsMin=false, bInDecimal=false, bCont=true;
  char *str = *strMsg;

  // go to first part of double (digit, minus sign or '.')
  while ( *str != '\0' && !isdigit(*str) && *str!='-' && *str!='.' ) {
    // when NaN or nan is double value, return -1000.0
    if ( (*str=='N' && strlen(str)>3 && *(str+1)=='a' && *(str+2)=='N' ) ||
	 (*str=='n' && strlen(str)>3 && *(str+1)=='a' && *(str+2)=='n' ) ) {
      *strMsg = str+3;
      return -1000.0;
    }
    else
       str++;
  }

  if ( *str != '\0' && *str=='-' ) {
    bIsMin=true;
    str++;
  }

  while( *str != '\0' && bCont ) {
    if ( *str=='.' )                           // in decimal part after '.'
      bInDecimal = true;
    else if ( bInDecimal && *str<='9' && *str>='0' ) {
      dFrac=dFrac*10.0;                        // shift decimal part to right
      dRes += (double)(*str-'0')/dFrac;        // and add number
    }
    else if ( *str<='9' && *str>='0' )          // if number and not decimal
      dRes=dRes*10+(double)(*str-'0');         // shift left and add number
    else if ( *str=='e' ) {
      if ( *(str+1) == '+' )                    // determine sign
        dRes *=  pow( 10, parseFirstInt(&str) ); // and multiply with power
      else if ( *(str+1) == '-' ) {
        str = str+2;                           // skip -
        dRes /=  pow( 10, parseFirstInt(&str) ); // and divide by power
      }
      bCont = false;                           // after 'e' stop
    }
    else
      bCont = false;                           // all other cases stop

    if( bCont == true )                        // update when not stopped yet
      str++;
  }
  *strMsg = str;
  return ( bIsMin && dRes != 0.0 ) ? -dRes : dRes;
}

