#ifndef _PLAYER_H
#define _PLAYER_H

#include <WorldState.h>
#include <PFLocalization.h>

#include "Connection.h"
#include "Logger.h"

extern Logger Log;
using namespace std;

class Player
{
 private:
  int timeLastSeeMessage;
  int timeLastSenseMessage;
  int timeLastAction; 
  bool bContinueLoop;

  WorldState *WS;
  Connection *C;
  PFLocalization *L;

 public:
  Player( WorldState *ws, Connection *c,
	  PFLocalization *l );
  void mainLoop();
  void act();
  void figure8();
  
  void paramWalk( double dx, double dy, double dt );
  void moveHead( double dp, double dt );
  void strafeRight();
  void strafeLeft();
  void fastWalk();
  void oneLayerHeadScan();

  int getCurrentTime();

  void setTimeLastSeeMessage( int t = -1 );
  void setTimeLastSenseMessage( int t ); 
  void setTimeLastAction( int t = -1 ); 
  
  void processLandmarkInfo( int id, int dist, int ang, 
			    int certainty );

  void processLinePixInfo( int id, int dist, int ang, 
			   int certainty );

  void processHeadSense( int pan, int tilt );

  bool timeToAct();

  bool analyzeMessage( char *msg ); 
  bool analyzeSeeMessage( char *msg ); 
  bool analyzeSenseMessage( char *msg ); 

} ;

#endif //_PLAYER_H
